import React from "react";
import {Button, ButtonGroup, Col, Container, Row} from "react-bootstrap";
import {MyInfo} from "./MyInfo";
import {MyHelp} from "./MyHelp";
import {SeekHelp} from "./SeekHelp";
import {User} from "../entity";

enum Menu {
    info="个人信息",
    seekHelp="我的求助",
    help="我的帮助"
}

/**
 * 个人信息
 */
export class MyMessage extends React.Component<{ user:string,onUserUpdate:Function }, { subMenu:Menu,page:JSX.Element }>{


    constructor(props: Readonly<any>) {
        super(props);

        this.state={
            subMenu:Menu.info,
            page:<MyInfo onUserUpdate={(user:User)=>this.props.onUserUpdate(user)} userId={this.props.user} isMyFriend={false} isOwn={true} isAdd={false}/>
        }
    }

    //切换菜单
    changeMenu(menu:Menu){
        this.setState({subMenu:menu})
        switch (menu) {
            case Menu.info:
                this.setState({page:<MyInfo onUserUpdate={(user:User)=>this.props.onUserUpdate(user)} userId={this.props.user} isMyFriend={false} isOwn={true} isAdd={false}/>})
                break
            case Menu.help:
                this.setState({page:<MyHelp/>})
                break
            case Menu.seekHelp:
                this.setState({page:<SeekHelp user={this.props.user}/>})
                break
        }
    }

    render() {
        return (
        <Container>
            <Row>
                <Col>
                    <ButtonGroup aria-label="Basic example">
                        {[Menu.info,Menu.seekHelp,Menu.help].map((menu:Menu,index:number)=><Button onClick={()=>this.changeMenu(menu)} key={"button"+index} variant={menu===this.state.subMenu?"primary":"light"}>{menu}</Button>)}
                    </ButtonGroup>
                </Col>
            </Row>
            <Row>
                {this.state.page}
            </Row>
        </Container>);
    }
}
